#ifndef ERROR_H
#define ERROR_H

#include "common/common.h"
#include "common/setup.h"

/********************************************
 *   Error manager structures and handlers  *
 ********************************************/

typedef enum {INFO,WARNING,CRITICAL,PANIC} GravityLevel;

void errorInit();
void errorDestroy();
void addError(GravityLevel, const char *, ...);
void printErrorStack();

typedef struct ErrorElem_
{
    GravityLevel gravity;
    char message[ERRORMSG_SIZE];
} ErrorElem;

struct ErrorList_ 
{
    long size;
    long top;
    ErrorElem *list;
};

typedef struct ErrorList_ ErrorList;

extern ErrorList errorManager;

#endif
